<template>
    <div class="page">
        <LayoutTable :data="tableData" :config="tableConfig">
                    </LayoutTable>


        <dialog-show ref="dialogform" @ok="getData" />
    </div>
</template>

<script>
    /** 表单弹出框模式需引入 */
    import dialogShow from "./dialogshow";
    import table from "@/assets/mixins/table";
    export default {
        name: "AppointmentConstraintList",
        components: {
            dialogShow
},
        mixins: [table],
        created() {
        },
        methods: {
            /** 重写新增方法 */
            toAdd(row) {
                this.$refs.dialogform.add(row);
            },
            /** 重写编辑方法 */
            toEdit(row) {
                this.$refs.dialogform.edit(row);
            },
            /** 重写查看方法 */
            toView(row) {
                this.$refs.dialogform.view(row);
            },

          handleConstraint(row,type) {
            let _this = this
            this.$confirm('取消约束后，系统将不向该群众推送此项服务，是否确认？', "系统服务", {
              confirmButtonText: "确定",
              cancelButtonText: "取消",
              type: "warning"
            }).then(function () {
              //todo
              _this.$post("/appointment/constraint/save", {
                id: row.id,
                constraint: type,
              })
                  .then((res) => {
                    if (res.code == 1) {
                      _this.$message.success("更改成功！");
                      _this.getData();
                    }
                  })
                  .catch((error) => {
                    this.$message.error(error.message);
                  });

            }).then(response => {

            })

          }
        },
        data() {
            return {
                config: {
                    search: [
                      {
                        name: "name",
                        type: "text",
                        label: "姓名",
                        fuzzy: true
                      }
                    ],
                    columns: [
                        {type: "selection", width: 60},
                        {type: "index",label: "序号",width: 50},

                        {label: "姓名", prop: "name"},

                        {label: "联系方式", prop: "contact"},

                        {label: "证件类型", prop: "idCardType"},

                        {label: "证件号码", prop: "idCardNo"},

                        {label: "累计次数", prop: "accumulative", formatter: this.formatter},

                        {label: "约束时间", prop: "constraintTime", formatter: this.formatterDate},

                        {label: "创建方式", prop: "createMethod",formatter: this.formatter},

                      {label: "约束服务", prop: "constraint",formatter: this.formatter},

                        {label: "操作人员", prop: "operator"},

                        {
                            label: "操作",
                            width: 240,
                            formatter: row => {
                                return (
                                    <div>
                                    <table-buttons noAdd noView row={row} onEdit={this.toEdit} onView={this.toView} onDel={this.toDel} />
                                      <span> </span>
                                      {row.constraint === 0 ? (
                                          <el-button
                                              size="mini"
                                              type="text"
                                              icon="el-icon-open"
                                              onClick={() => {
                                                this.handleConstraint(row,1);
                                              }}
                                          >
                                            约束
                                          </el-button>
                                      ) : (
                                          <el-button
                                              size="mini"
                                              type="text"
                                              icon="el-icon-open"
                                              onClick={() => {
                                                this.handleConstraint(row,0);
                                              }}
                                          >
                                            取消约束
                                          </el-button>
                                      )}

                                    </div>
                            );
                            }
                        }
                    ]
                }
            };
        }
    };
</script>
